import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Random;
import java.util.ArrayList;

public class ArithmeticOperatorGame
{
   public static void main(String[] args)
   {
      ArithmeticOperatorView game = new ArithmeticOperatorView();
      game.setVisible(true);
      
      // the minimum and maximum value of an operand
      final int MIN_OPERAND_VALUE = 1;
      final int MAX_OPERAND_VALUE = 10;
      
      // the number of operands
      final int NUM_OPERANDS = 5;
      
      // true if a new expression is needed (when the game first
      // starts and every time after an expression is checked
      // for correctness)
      boolean expressionNeeded = true;
      
      while (true)
      {
         try
         {
            Thread.sleep(100);
         }
         catch(InterruptedException x)
         {
         }
         if (expressionNeeded)
         {
            game.makeExpression(NUM_OPERANDS, MIN_OPERAND_VALUE, MAX_OPERAND_VALUE);
            expressionNeeded = false;
         }
         else if (game.answerSubmitted())
         {
            String ex = game.getExpression();
            List<String> operands = new ArrayList<String>();
            List<Character> operators = new ArrayList<Character>();
            int operandsRemaining = NUM_OPERANDS;
            while (operandsRemaining > 0)
            {
               if (operandsRemaining == 1)
               {
                  operands.add(ex);
               }
               else
               {
                  int idx = ex.indexOf(' ');
                  operands.add(ex.substring(0, idx));
                  ex = ex.substring(idx + 1);
                  operators.add(ex.charAt(0));
                  ex = ex.substring(2);
               }
               operandsRemaining--;
            }
            
            for(int i = 0; i < operands.size(); ++i)
            {
               String s = operands.get(i);
               if (s.indexOf('x') > -1)
               {
                  int x = game.getX();
                  if (s.equals("-x"))
                  {
                     x = -x;
                  }
                  else if (s.equals("++x"))
                  {
                     ++x;
                  }
                  else if (s.equals("--x"))
                  {
                     --x;
                  }
                  operands.set(i, String.valueOf(x));
                  break;
               }
            }
            StringBuffer stepBuf = new StringBuffer(operands.get(0));
            for(int i = 0; i < operators.size(); ++i)
            {
               stepBuf.append(" ");
               stepBuf.append(operators.get(i));
               stepBuf.append(" ");
               stepBuf.append(operands.get(i + 1));
            }
            String step = stepBuf.toString();
            StringBuffer solutionBuf = new StringBuffer();
            solutionBuf.append("y = " + step + '\n');
            
            while (operators.size() > 0)
            {
               int index = -1;
               for(int i = 0; i < operators.size(); ++i)
               {
                  char op = operators.get(i);
                  if (op == '*' || op == '/' || op == '%')
                  {
                     index = i;
                     break;
                  }
               }
               if (index == -1)
               {
                  index = 0;
               }
               int left = Integer.parseInt(operands.get(index));
               int right = Integer.parseInt(operands.get(index + 1));
               char op = operators.get(index);
               int value = 0;
               switch (op)
               {
               case '+':
                  value = left + right;
                  break;
               case '-':
                  value = left - right;
                  break;
               case '*':
                  value = left * right;
                  break;
               case '/':
                  value = left / right;
                  break;
               case '%':
                  value = left % right;
                  break;
               }
               String subex = String.valueOf(left) +
                                 " " + op + " " + 
                                 String.valueOf(right);
               String parenSubex = "(" + subex + ")";
               step = step.replace(subex, parenSubex);
               solutionBuf.append("  = " + step + '\n');
               step = step.replace(parenSubex, String.valueOf(value));
               solutionBuf.append("  = " + step + '\n');
               operands.set(index, String.valueOf(value));
               operands.remove(index + 1);
               operators.remove(index);
            }
            String y = operands.get(0);
            if (y.equals(game.getSubmittedAnswer()))
            {
               game.showCongratulation();
            }
            else
            {
               game.showSolution(solutionBuf.toString());
            }
            expressionNeeded = true;
         }
      }
      
   }
}
